#!/usr/bin/python
# -*- coding: utf-8 -*-

"""
Rozwiązanie zadania 215.
"""

from deterministic_automaton import DeterministicAutomaton


def four_automaton():
    automaton = DeterministicAutomaton()

    state_a = automaton.add_state()
    state_b = automaton.add_state()
    state_c = automaton.add_state()
    state_d = automaton.add_state()
    state_e = automaton.add_state()
    automaton.mark_as_initial(state_a)
    automaton.mark_as_final(state_a)
    automaton.mark_as_final(state_e)


    automaton.add_transition(state_a, "0", state_e)
    automaton.add_transition(state_e, "4", state_a)
    automaton.add_transition(state_e, "8", state_a)

    automaton.add_transition(state_e, "1", state_a)
    automaton.add_transition(state_e, "5", state_a)
    automaton.add_transition(state_e, "9", state_a)

    automaton.add_transition(state_e, "2", state_a)
    automaton.add_transition(state_e, "6", state_a)

    automaton.add_transition(state_e, "3", state_a)
    automaton.add_transition(state_e, "7", state_a)



    automaton.add_transition(state_a, "4", state_a)
    automaton.add_transition(state_a, "8", state_a)

    automaton.add_transition(state_a, "1", state_b)
    automaton.add_transition(state_a, "5", state_b)
    automaton.add_transition(state_a, "9", state_b)

    automaton.add_transition(state_a, "2", state_c)
    automaton.add_transition(state_a, "6", state_c)

    automaton.add_transition(state_a, "3", state_d)
    automaton.add_transition(state_a, "7", state_d)
    #-----------------------------------------1

    automaton.add_transition(state_b, "0", state_c)
    automaton.add_transition(state_b, "4", state_c)
    automaton.add_transition(state_b, "8", state_c)

    automaton.add_transition(state_b, "1", state_d)
    automaton.add_transition(state_b, "5", state_d)
    automaton.add_transition(state_b, "9", state_d)

    automaton.add_transition(state_b, "2", state_a)
    automaton.add_transition(state_b, "6", state_a)

    automaton.add_transition(state_b, "3", state_b)
    automaton.add_transition(state_b, "7", state_b)
    # -----------------------------------------2

    automaton.add_transition(state_c, "0", state_a)
    automaton.add_transition(state_c, "4", state_a)
    automaton.add_transition(state_c, "8", state_a)

    automaton.add_transition(state_c, "1", state_b)
    automaton.add_transition(state_c, "5", state_b)
    automaton.add_transition(state_c, "9", state_b)

    automaton.add_transition(state_c, "2", state_c)
    automaton.add_transition(state_c, "6", state_c)

    automaton.add_transition(state_c, "3", state_d)
    automaton.add_transition(state_c, "7", state_d)
    # ----------------------------------------3

    automaton.add_transition(state_d, "0", state_c)
    automaton.add_transition(state_d, "4", state_c)
    automaton.add_transition(state_d, "8", state_c)

    automaton.add_transition(state_d, "1", state_d)
    automaton.add_transition(state_d, "5", state_d)
    automaton.add_transition(state_d, "9", state_d)

    automaton.add_transition(state_d, "2", state_a)
    automaton.add_transition(state_d, "6", state_a)

    automaton.add_transition(state_d, "3", state_b)
    automaton.add_transition(state_d, "7", state_b)
    # -----------------------------------------4

    return automaton

